from diagrams import Diagram
from diagrams.c4 import Person, Container, System, Relationship

graph_attributes = {
    "resolution": "256",
    "margin": "-2",
    "splines": "spline",
}

def create_diagram():
    with Diagram(name="", filename="out/system_context", show=False, direction="TB", graph_attr=graph_attributes):
        user = Person(name="User", description="A user of the SmartEating platform")
        smarteating = System(name="SmartEating Platform", technology="React, Python", external=False, width="2.3")
        openai_api = System(name="OpenAI API", external=True)
        inhouse_llm_api = System("InHouse LLM API", external=True)

        user >> Relationship("Interacts with") >> smarteating
        smarteating >> Relationship("Sends requests to") >> openai_api
        openai_api >> Relationship("Returns processed request to") >> smarteating
        smarteating >> Relationship("Sends requests to") >> inhouse_llm_api
        inhouse_llm_api >> Relationship("Returns processed request to") >> smarteating


if __name__ == '__main__':
    create_diagram()
